import { SharedAccessMode } from "../SharedDocuments/types";
export type ExtractedTableData = {
    rows: {
        length: number;
    }[];
    cols: {
        length: number;
    }[];
    cells: {
        row: number;
        col: number;
        spanRows: number;
        spanCols: number;
        text: string;
    }[];
};
export type TableDataExportFormat = "csv" | "json" | "xlsx" | "xml" | "html";
export declare class DocumentInfo {
    title: string;
    creator: string;
    producer: string;
    author: string;
    subject: string;
    keywords: string;
    creationDate?: string;
    modifyDate?: string;
}
export declare class OpenDocumentInfo {
    accessMode: SharedAccessMode;
    documentId: string;
    fileName: string;
    pagesCount: number;
    defaultViewPortSize: {
        w: number;
        h: number;
    };
    info: DocumentInfo;
    constructor(params: {
        accessMode: SharedAccessMode;
        documentId: string;
        fileName: string;
        pagesCount: number;
        defaultViewPortSize: {
            w: number;
            h: number;
        };
        info: DocumentInfo;
    });
}
export type DocumentModification = {
    renderInteractiveForms?: boolean;
    rotation?: number;
    formData?: any;
    annotationsData?: {
        newAnnotations: any[];
        updatedAnnotations: any[];
        removedAnnotations: any[];
    };
};
