import { ViewerOptions } from "../ViewerOptions";
import { UndoCommandSupport } from "./Commands/UndoCommandSupport";
export interface IUndoStorage {
    applyOptions(options: Partial<ViewerOptions>): any;
    dispose(): any;
    clear(): any;
    isCommandSupported(command: UndoCommandSupport): boolean;
    execute(command: UndoCommandSupport): Promise<void>;
    onCommandExecuted(command: UndoCommandSupport): any;
    undo(): Promise<void>;
    redo(): Promise<void>;
    get hasUndo(): boolean;
    get hasRedo(): boolean;
    get undoIndex(): number;
    get undoCount(): number;
    get undoInProgress(): boolean;
    get commands(): UndoCommandSupport[];
}
